<div
  class="full-width overflow-hidden m-b-20"
  [formGroup]="subFormGroup"
  [attr.data-test-element-id]="reportInput.name"
>
  <div class="m-b-10">
    <span class="label-color" [attr.data-test-element-id]="'criteria-name'">{{
      reportInput.label
    }}</span>
    <!--    As 2.0 the only possible error here is 'required' so no need to make multiple error system-->
    @if (errors) {
      <span
        [attr.data-test-element-id]="'criteria-errors'"
        class="m-l-10 sqtm-core-error-message"
      >
        {{ 'sqtm-core.validation.errors.required' | translate }}
      </span>
    }
  </div>
  <div class="full-width p-l-20 p-b-5">
    @switch (reportInput.type) {
      @case (ReportInputType.RADIO_BUTTONS_GROUP) {
        <nz-radio-group
          [formControlName]="reportInput.name"
          (ngModelChange)="showControl($event)"
        >
          @for (option of reportInput.options; track option) {
            @if (isTagPickerVisible(option) | async) {
              <label
                class="flex-row"
                nz-radio
                [nzValue]="option.value"
                [attr.data-test-option-id]="option.givesAccessTo || option.name"
              >
                <span class="m-r-20">{{ option.label }}</span>
                @switch (option.contentType) {
                  @case (ReportInputType.PROJECT_PICKER) {
                    <sqtm-app-form-project-picker
                      [formControlName]="option.givesAccessTo"
                    >
                    </sqtm-app-form-project-picker>
                  }
                  @case (ReportInputType.MILESTONE_PICKER) {
                    <sqtm-app-form-milestone-picker
                      [formControlName]="option.givesAccessTo"
                    >
                    </sqtm-app-form-milestone-picker>
                  }
                  @case (ReportInputType.TREE_PICKER) {
                    @if (option.nodeType === 'TEST_CASE') {
                      <sqtm-app-form-test-case-tree-picker
                        [formControlName]="option.givesAccessTo"
                      ></sqtm-app-form-test-case-tree-picker>
                    }
                    @if (option.nodeType === 'REQUIREMENT') {
                      <sqtm-app-form-requirement-tree-picker
                        [formControlName]="option.givesAccessTo"
                      >
                      </sqtm-app-form-requirement-tree-picker>
                    }
                    @if (option.nodeType === 'CAMPAIGN') {
                      <sqtm-app-form-campaign-tree-picker
                        [restrictedRowType]="option.nodeType"
                        [enabledMultiSelection]="option.composite"
                        [formControlName]="option.givesAccessTo"
                      >
                      </sqtm-app-form-campaign-tree-picker>
                    }
                  }
                  @case (ReportInputType.TAG_PICKER) {
                    <sqtm-app-form-tag-picker
                      [bindableEntity]="option.bindableEntity"
                      [criteriaFormControlName]="option.givesAccessTo"
                      [criteriaFormGroup]="subFormGroup"
                    >
                    </sqtm-app-form-tag-picker>
                  }
                }
              </label>
            }
          }
        </nz-radio-group>
      }
      @case (ReportInputType.CHECKBOXES_GROUP) {
        <div class="full-width m-t-5">
          <nz-checkbox-wrapper>
            @for (option of reportInput.options; track option) {
              <div nz-row>
                <label
                  nz-checkbox
                  [formControlName]="option.givesAccessTo"
                  [attr.data-test-option-id]="
                    option.givesAccessTo || option.name
                  "
                  [class.m-l-10]="option.disabledBy != null"
                  [class.disabled-option]="optionIsDisabled(option)"
                >
                  {{ option.label }}
                </label>
              </div>
            }
          </nz-checkbox-wrapper>
        </div>
      }
      @case (ReportInputType.DROPDOWN_LIST) {
        <nz-select [formControlName]="reportInput.name" style="width: 200px">
          @for (option of reportInput.options; track option) {
            <nz-option [nzValue]="option.value" [nzLabel]="option.label">{{
              option.label
            }}</nz-option>
          }
        </nz-select>
      }
      @case (ReportInputType.TEMPLATE_DROPDOWN_LIST) {
        <nz-select
          [formControlName]="reportInput.name"
          style="width: 100%"
          nzShowSearch
        >
          @for (option of reportInput.options; track option) {
            <nz-option [nzValue]="option.value" [nzLabel]="option.label">{{
              option.label
            }}</nz-option>
          }
        </nz-select>
      }
    }
  </div>
</div>
